#!/bin/sh
#
# Licensed materials - Property of IBM
# 5724-T07 Copyright IBM Corp. 2008, 2010
# All rights reserved
# US Government users restricted rights  -  Use, duplication or
# disclosure restricted by GSA ADP schedule contract with IBM Corp.
#
# Shell script to start RSE daemon
setConfig() {
 if test $1 
 then
    _RSE_CONFIG=$1
    echo RSE configuration files located in $_RSE_CONFIG
  else
    _RSE_CONFIG=../bin
    echo RSE configuration files located in $_RSE_CONFIG --default
  fi
}


setPort() {
  if test $1
  then
    _RSE_PORT=$1
    echo RSE daemon port is $_RSE_PORT 
  else
    _RSE_PORT=4035
    echo RSE daemon port is $_RSE_PORT --default
  fi
}  
    
checkLinux() {
  if test "$1" = "RedHat"
  then 
    _linux=$1
  else
    if test "$1" = "SuSe"
    then
      _linux=$1
    fi
  fi
}

checkShutdownCommand() {
    if test "$1" = "shutdown" -o "$1" = "SHUTDOWN" 
    then
      _consoleCommand="STOP"
    fi
}

checkCommand() {
  if test "$1" = "command" -o "$1" = "COMMAND"
  then
     _consoleCommand=$2
  fi
}  
  
echo
date
id
echo

_DEFAULT_PORT=4035

if test "$1" = "ivp" -o "$1" = "IVP" 
then
  _RSE_DAEMON_IVP_TEST=1
  _RSE_PWD_IVP=$(pwd)
  echo
  echo RSE daemon IVP test
  shift
else
  if test $1 
  then
    checkLinux $1 

    if test $2
    then
      checkShutdownCommand $2

      if test $_consoleCommand
      then
        setPort 
        setConfig
      else
        checkShutdownCommand $3
        if test $_consoleCommand
        then 
          setPort $2
          setConfig
        else
          checkShutdownCommand $4
          if test $_consoleCommand
          then 
            setPort $2
            setConfig $3
          else
            checkCommand $2 $3
            if test $_consoleCommand
            then
              setPort
              setConfig
              # todo set up the additional parms....
            else
            checkCommand $3 $4
            if test $_consoleCommand
            then
              setPort $2
              setConfig
                  for i in $@
                  do
                    echo i : $i : $parmStart : $_consoleCommand : $_commandParms
                    if test $parmStart
                    then
                      if [ $parmStart -eq 1 ]
                      then
                        if test $_commandParms
                        then
                          _commandParms="$_commandParms $i"
                        else
                          _commandParms="$i"
                        fi
                      else
                        if [ $parmStart -eq 0 ]
                        then
                          parmStart=1
                        fi
                      fi
                    else
                      if test "$i" = "command" -o "$i" = "COMMAND"
                      then
                        parmStart=0
                      fi
                    fi 
                  done
                  echo ---------------------
                echo $_consoleCommand $_commandParms
                echo ---------------------                    
            else
              setPort $2
              setConfig $3  
            fi       
            fi
          fi
      fi
    fi
    else
      setPort
      setConfig
    fi
  fi
  
  if test $_linux
  then
    echo Linux version being used is $_linux
  else
    echo You must specify either SuSe or RedHat
    exit -1
  fi
fi

echo $_RSE_CONFIG
cd $_RSE_CONFIG
set -a
echo ">>" rsed.$_linux.envvars
rm ./rsed.envvars
cp ./rsed.$_linux.envvars ./rsed.envvars
. ./rsed.envvars
echo
echo current environment variables
echo
set
echo

if test $_RSE_DAEMON_IVP_TEST
then
  echo starting java...
  echo
  java -version 2>&1
  cd $_RSE_PWD_IVP
  echo
  echo RSE daemon IVP ended
else
  echo current class path: $CLASSPATH
  echo RSE_LIB: $RSE_LIB
  echo _RSE_JAVAOPTS: $_RSE_JAVAOPTS
  echo
  if test $_consoleCommand
  then
    echo java $_RSE_JAVAOPTS $_RSE_DAEMON_CLASS $_RSE_PORT  $EUID COMMAND $_consoleCommand $_commandParms 
    java $_RSE_JAVAOPTS $_RSE_DAEMON_CLASS $_RSE_PORT $EUID COMMAND $_consoleCommand $_commandParms 
  else
    echo java $_RSE_JAVAOPTS $_RSE_DAEMON_CLASS $_RSE_PORT
    java $_RSE_JAVAOPTS $_RSE_DAEMON_CLASS $_RSE_PORT
  fi
fi
